#!/bin/sh
# exiftool script for 2002 problem for QNAP
# created by: linux_@_giopas.eu

# take name of this script
scriptname=`basename "$0"`

# create the initial time stamp
TIMESTAMP1=$(date +"%Y-%m-%d %Hh:%M")

echo "$TIMESTAMP1 - INFO: '$scriptname' has started..." >&2

# create a log file
LOG="Exiftool.log"

if [ ! -e $LOG ]; then
	touch $LOG
	# send output to screen
	echo "$TIMESTAMP1 - INFO: '$LOG' does not exists but has been created..." >&2
else

	rm $LOG && touch $LOG
	# send output to screen
	echo "$TIMESTAMP1 - INFO: '$LOG' exists and it will be cleared and used..." >&2
fi

# set target directories
dir="/share/Multimedia/Pictures/"

# move to target directory
cd "$dir"

# obtain directory names
FOLDER="$(printf '%s\n' "${PWD##*/}")"

# check if folder is empty (-A for all files, without arguments only for non hidden files)
if
	[ "$(ls $dir)" ];

then

	# send output to screen
	echo "$TIMESTAMP1 - INFO: '${FOLDER}' is not empty and exiftool will be executed." >&2

	# execute command
	exiftool -overwrite_original -r '-CreateDate<DateTimeOriginal' -if '$CreateDate eq "2002:12:08 12:00:00"' -if '$DateTimeOriginal ne $CreateD
	ate' *.[Jj][Pp][Gg] > $LOG

	# get last line of the output
	OUTPUT="$(gawk '/./{line=$0} END{print line}' $LOG)"

# create the final time stamp
TIMESTAMP2=$(date +"%Y-%m-%d %Hh:%M")
	
	# send output to screen
	echo "$TIMESTAMP2 - INFO: ${OUTPUT}." >&2

	# notify to QTS
	/sbin/notice_log_tool -a "Exiftool cronjob completed on '${FOLDER}': ${OUTPUT}." -t 5
	/sbin/log_tool -a "Exiftool cronjob completed on '${FOLDER}': ${OUTPUT}." -t 0
	exit 0

else

	# send output to screen
	echo "$TIMESTAMP1 - INFO: '${FOLDER}' is empty and exiftool has not been executed." >&2

	# notify to QTS
	/sbin/notice_log_tool -a "'${FOLDER}' is empty and exiftool has not been executed." -t 5
	/sbin/log_tool -a "'${FOLDER}' is empty and exiftool has not been executed." -t 0
	exit 0
fi 
